﻿// Copyright 2011 L'Express de Toronto Inc.
// June 23, 2011
// Written by Kasyan Servetsky
// http://www.kasyan.ho.com.ua
// e-mail: askoldich@yahoo.com
//==========================================================================================================================

if (app.documents.length == 0) ErrorExit("Please open a document and try again.");

var gScriptName = "Thread two selected frames";
var gScriptVersion = "1.2";
var gDoc = app.activeDocument;
var sel = gDoc.selection;
if (gDoc.selection.length != 2) ErrorExit("Two text frames should be selected.");
if (sel[0].constructor.name != "TextFrame" || sel[1].constructor.name != "TextFrame") ErrorExit("Two text frames should be selected.");

ProcessSelection(sel);

//===================================================== FUNCTIONS  ========================================================
function ProcessSelection(sel) {
	var titleFrame, bodyFrame;
	
	if (HasTitle(sel[0]) && !HasTitle(sel[1])) {
		titleFrame = sel[0];
		bodyFrame = sel[1];
	}
	else if (HasTitle(sel[1]) && !HasTitle(sel[0])) {
		titleFrame = sel[1];
		bodyFrame = sel[0];
	}
	else { // no title was found
		ErrorExit("The \"Title\" text frame has not been found.");
	}

	titleFrame.insertionPoints[-1].contents = "\r";
	//titleFrame.insertionPoints[-1].contents = SpecialCharacters.FRAME_BREAK;

	if (titleFrame.nextTextFrame == null) titleFrame.nextTextFrame = bodyFrame; 
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function RoundWithDecimal(number, decimals) {
    var multiplier = Math.pow(10,decimals);
    return Math.round(number*multiplier)/multiplier;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function HasTitle(tf) {
	var finds;
	var result = false;
	app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.nothing;
	app.findGrepPreferences.findWhat = ".+";
	app.findGrepPreferences.appliedParagraphStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal");
	finds = tf.findGrep();
	if (finds.length > 0) {
		result = true;
	}
	else {
		app.findGrepPreferences.appliedParagraphStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal.mince");
		finds = tf.findGrep();
		if (finds.length > 0) result = true;
	}
	
	return result;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ErrorExit(error, icon) {
	alert(error, gScriptName + " - " + gScriptVersion, icon);
	exit();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------